---
title: WebVR — Virtual Reality for the Web
slug: Games/Techniques/3D_on_the_web/WebVR
tags:
  - 3D
  - Games
  - WebGL
  - WebVR
---
<div>{{GamesSidebar}}</div>

<p class="summary">The concept of virtual reality in itself isn't new, but now we have the technology to have it working as it should be, and a JavaScript API to make use of it in web applications. This article introduced WebVR from the perspective of its use in games.</p>

<div class="notecard note">
<p><strong>Note</strong>: WebVR API is replaced by <a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a>. WebVR was never ratified as a standard, was implemented and enabled by default in very few browsers and supported a small number of devices.</p>
</div>

<h2 id="VR_devices">VR devices</h2>

<p>With the popularity of Oculus Rift and a lot of other devices in production coming soon to the market, the future looks bright — we already have sufficient technology to make the VR experience "good enough" for playing games. There are many devices to chose from: desktop ones like Oculus Rift or HTC Vive, through consoles with Playstation VR (which admittedly doesn't support WebVR at this time), to mobile experiences like Gear VR or Google Cardboard.</p>

<p><img alt="" src="http://end3r.com/tmp/vr/hmds.jpg" style="border-style: solid; border-width: 1px; display: block; margin: 0px auto;"></p>

<div class="note">
<p><strong>Note</strong>: For more information, read our <a href="/en-US/docs/Web/API/WebVR_API/WebVR_concepts">WebVR Concepts</a> article.</p>
</div>

<h2 id="The_WebVR_API">The WebVR API</h2>

<p>The <a href="/en-US/docs/Web/API/WebVR_API">WebVR API</a> is the central API for capturing information on VR Devices connected to a computer and headset position/orientation/velocity/acceleration information, and converting that into useful data you can use in your games and other applications.</p>

<div class="note">
<p><strong>Note</strong>: There are of course other APIs useful for creating games, for example <a href="/en-US/docs/Web/API/Gamepad_API">The Gamepad API</a> for control inputs, and the <a href="/en-US/docs/Web/API/Detecting_device_orientation">Device Orientation API</a> for handling display orientation on mobile.</p>
</div>

<h3 id="Browser_support_and_spec_status">Browser support and spec status</h3>

<p>Currently browser support for the WebVR API is still experimental — it works in <a href="https://nightly.mozilla.org/">nightly builds of Firefox</a> and <a href="https://drive.google.com/folderview?id=0BzudLt22BqGRbW9WTHMtOWMzNjQ&amp;usp=sharing#list">experimental builds of Chrome</a> (Mozilla and Google teamed up to work on the implementation together), but sooner rather than later we'll see it in regular builds.</p>

<p>The <a href="https://mozvr.github.io/webvr-spec/webvr.html">WebVR spec</a> is in Editor's Draft status which means it is still subject to change. The development is led by <a href="https://twitter.com/vvuk">Vladimir Vukicevic</a> from Mozilla and <a href="https://twitter.com/tojiro">Brandon Jones</a> from Google. For more info be sure to visit the <a href="http://mozvr.com/">MozVR.com</a> and <a href="http://webvr.info/">WebVR.info</a> websites.</p>

<h3 id="Using_the_WebVR_API">Using the WebVR API</h3>

<p>The WebVR API is based on two concepts — sending <a href="/en-US/docs/Web/API/WebVR_API/WebVR_concepts#Stereoscopic_vision">stereoscopic images</a> to both lenses in your headset and receiving positional data for your head from the sensor, and those two are handled by {{domxref("HMDVRDevice")}} (head-mounted display virtual reality device) and {{domxref("PositionSensorVRDevice")}}.</p>

<h3 id="Get_the_devices">Get the devices</h3>

<p>To get information about devices connected to your computer, you can use the {{domxref("Navigator.getVRDevices")}} method:</p>

<pre class="brush: js notranslate">navigator.getVRDevices().then(function(devices) {
  for (var i = 0; i &lt; devices.length; ++i) {
    if (devices[i] instanceof HMDVRDevice) {
      gHMD = devices[i];
      break;
    }
  }
  if (gHMD) {
    for (var i = 0; i &lt; devices.length; ++i) {
      if (devices[i] instanceof PositionSensorVRDevice
      	 &amp;&amp; devices[i].hardwareUnitId === gHMD.hardwareUnitId) {
        gPositionSensor = devices[i];
        break;
      }
    }
  }
});</pre>

<p>This code will loop through the available devices and assign proper sensors to the headsets — the first <code>devices</code> array contains the connected devices, and a check is done to find the {{domxref("HMDVRDevice")}}, and assign it to the <code>gHMD</code> variable — using this you can set up the scene, getting the eye parameters, setting the field of view, etc. For example:</p>

<pre class="brush: js notranslate">function setCustomFOV(up,right,down,left) {
  var testFOV = new VRFieldOfView(up,right,down,left);

  gHMD.setFieldOfView(testFOV,testFOV,0.01,10000.0);
}</pre>

<p>The <code>gPositionSensor</code> variable holds the {{domxref("PositionSensorVRDevice")}} — using this you can get the current position or orientation state (for example to update the scene view on every frame), or reset the sensor. For example, the below code outputs position information on the screen:</p>

<pre class="brush: js notranslate">function setView() {
  var posState = gPositionSensor.getState();

  if(posState.hasPosition) {
    posPara.textContent = 'Position: x' + roundToTwo(posState.position.x) + " y"
                                + roundToTwo(posState.position.y) + " z"
                                + roundToTwo(posState.position.z);
    xPos = -posState.position.x * WIDTH * 2;
    yPos = posState.position.y * HEIGHT * 2;
    if(-posState.position.z &gt; 0.01) {
      zPos = -posState.position.z;
    } else {
      zPos = 0.01;
    }
  }

  ...

}</pre>

<p>For a full explanation and more details of the demo this is taken from, see <a href="/en-US/docs/Web/API/WebVR_API/Using_the_WebVR_API">Using the WebVR API</a>.</p>

<h2 id="Tools_and_techniques">Tools and techniques</h2>

<p>The first WebVR experiments and demos used Three.js as it's probably the most popular 3D engine for the web. See the <a href="https://github.com/mrdoob/three.js/blob/master/examples/js/effects/VREffect.js">VREffect</a> and <a href="https://github.com/mrdoob/three.js/blob/master/examples/js/controls/VRControls.js">VRControls</a> functions available on the Three.js github to help you implement and handle WebVR with Three.js.</p>

<p><img alt="" src="http://end3r.com/tmp/vr/sechelt.jpg" style="border-style: solid; border-width: 1px; display: block; margin: 0px auto;"></p>

<p>Boris Smus has written about the concept of <a href="http://smus.com/responsive-vr/">Responsive WebVR</a>, where a single web game can be played on various devices like laptops without VR hardware, PCs with Oculus Rift, or smartphones inside Google Cardboard and still deliver a unique and valuable experience across all of them. It's like responsive design, but applied to the VR world — write once and run in any VR headset ... or without it. You can check the <a href="http://github.com/borismus/webvr-boilerplate">WebVR Boilerplate</a> sources — it's a good example to start learning WebVR from, and a starting point for any web-based VR experience.</p>

<p>There's also a markup framework called <a href="https://aframe.io/">A-Frame</a> that offers simple building blocks for WebVR, so you can rapidly build and experiment with VR websites and games: read the <a href="/en-US/docs/Games/Techniques/3D_on_the_web/Building_up_a_basic_demo_with_A-Frame">Building up a basic demo with A-Frame</a> tutorial for more details.</p>

<p>Immersion is more important than gameplay or graphics - you have to feel you're "inside" the experience. It's not easy to achieve, but it doesn't require realistic images. Quite the contrary as having a basic shapes flying around in high framerate can make a lot. Remember: experimenting is key - see what works for your game in particular.</p>

<h2 id="The_future_of_WebVR">The future of WebVR</h2>

<p>It's happening — consumer devices are reaching the market right now, and we already have JavaScript APIs to support them on the Web. All we need now is a stable specification, good UX and UI, better hardware and more tools and libraries — and all of that is on the horizon. It's the perfect time to dive in and experiment with WebVR.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebVR_API">WebVR API</a></li>
 <li><a href="/en-US/docs/Web/API/WebVR_API/WebVR_concepts">WebVR concepts</a></li>
 <li><a href="/en-US/docs/Web/API/WebVR_API/Using_the_WebVR_API">Using the WebVR API</a></li>
 <li><a href="/en-US/docs/Games/Techniques/3D_on_the_web/Building_up_a_basic_demo_with_A-Frame">Building up a basic demo with A-Frame</a></li>
</ul>
